<?php
function strip_nl($string) {
	$newstring=mysql_escape_string(trim(str_replace("\n"," ",$string)));
	return $newstring;
}


function parse_text($text) {
$tarray=explode("\n",$text);
$cluster=array();
$clcount=array();

$current_var="unknown";
foreach ($tarray as $line) {
	if ($line || $current_var=="Abstract") {
		if (preg_match("/^([^ :]*):(.*)$/i",$line,$matches)) {
			$current_var=$matches[1];
		  if (preg_match("/^(Provider|Publisher|Editor|Author|File)-(.*)$/i",$current_var,$clmatches)) {
				$tcluster=strtolower($clmatches[1]);
				if ($clmatches[2]=="Name" || $clmatches[2]=="URL") {
					if (isset($clcount[$tcluster])) $clcount[$tcluster]++;
						else $clcount[$tcluster]=0;
					}
				$cluster[$tcluster][$clcount[$tcluster]][$current_var]=trim($matches[2]);
				}
			   else {
				$rarray[$current_var]=trim($matches[2]);
				}
			} 
		   else {
                  if (preg_match("/^(Provider|Publisher|Editor|Author|File)-(.*)$/i",$current_var,$clmatches)) { 
                                $tcluster=strtolower($clmatches[1]);                       
                                $cluster[$tcluster][$clcount[$tcluster]][$current_var]=$cluster[$tcluster][$clcount[$tcluster]][$current_var]."\n".$line;
                                }
                           else {
				$rarray[$current_var]=$rarray[$current_var]."\n".$line;
				}
			}
		}
	}

// copy clusters:

while(list($k, $v) = each($cluster)) {
        unset($v[""]);
	$rarray[$k]=$v;
}

//strip handle
if (isset($rarray['Handle'])) {
	$rarray['Full-Handle']=$rarray['Handle'];
	$rarray['Handle']=preg_replace("/^.*:([^:]+)$/i","\${1}",$rarray['Full-Handle']);
	$rarray['Handle']=strip_nl($rarray['Handle']);
	}
return $rarray;

}


function parse_archive($ar_location,$ar_name) {

// get archive file
$arfile=$ar_location."/".$ar_name."arch.rdf";
$handle = fopen ($arfile, "rb");
$arcontents = fread ($handle, filesize ($arfile));
fclose ($handle);

// parse archive
$archive['archive']=parse_text($arcontents);


//get series file
$serfile=$ar_location."/".$ar_name."seri.rdf";
$handle = fopen ($serfile, "rb");
$sercontents = fread ($handle, filesize ($serfile));
fclose ($handle);

// split series ...
$i=-1;
$scarray[$i]="";

$sfarray=explode("\n",$sercontents);
foreach ($sfarray as $line) {
	if (eregi("Template-Type",$line)) { $i++; $scarray[$i]=""; }
	$scarray[$i]=$scarray[$i]."\n".$line;
	}
unset($scarray[-1]);

$si=0;

// go through series
foreach ($scarray as $stext) {
	// parse series
	$tsarray=parse_text($stext);
	
	// now do the papers for this series ...
	$papdir=$ar_location."/".$tsarray['Handle'];
	if (is_dir($papdir) && $tsarray['Handle']) {

		// read in rdf filenames in series dir
		$papfiles=array();
		$handle=opendir($papdir);
		while ($file = readdir ($handle)) {
    			if (preg_match("/^.*\.rdf$/i",$file)) {
        			$papfiles[]=$file;
    				}
			}
		closedir($handle);
		sort($papfiles);

		// read in rdf files and concatenate them
		$papcontents="";
		foreach($papfiles as $papfile) {
			$tpapfile=$papdir."/".$papfile;
			$handle = fopen ($tpapfile, "rb");
			$papcontents =$papcontents."\n".fread($handle,filesize($tpapfile));
			fclose ($handle);
			}

		// split papers ...
		$pcarray=array();
		$i=-1;
		$pcarray[$i]="";

		$pfarray=explode("\n",$papcontents);
		foreach ($pfarray as $line) {
			if (eregi("Template-Type",$line)) { $i++; $pcarray[$i]=""; }
        		$pcarray[$i]=$pcarray[$i]."\n".$line;
        		}
		unset($pcarray[-1]);

		// go through papers and parse them
		$pi=0; $tparray=array();
		foreach ($pcarray as $ptext) {
			$tparray[$pi]=parse_text($ptext);
			$pi++;
			}

		$tsarray['papers']=$tparray;
		}
	  else  {
		$tsarray['papers']=array();
		}

	$sarray[$si]=$tsarray;
	$si++;
	}

$archive['series']=$sarray;

return $archive;
}

function import_archive($archive) {
   global $db_host, $db_user, $db_pass, $db_name;

   $connection = mysql_connect($db_host, $db_user, $db_pass) or die
                          ("Unable to connect!");
   mysql_select_db($db_name);

// check if archive entry exists, if not: create it

   $query = "SELECT *
             FROM wp_archive
             WHERE ar_id='1'";
   $result = mysql_query($query, $connection) or die ("Error in
                         query: $query. " . mysql_error());

   if (mysql_num_rows($result) == 0) {
                $query = "INSERT INTO wp_archive SET ar_id=1";
                $result = mysql_query($query, $connection) or die ("Error in
                         query: $query. " . mysql_error());
                }

// get archive stuff
$ararray=$archive['archive'];


// save archive stuff

   $query = "UPDATE wp_archive
             SET
                Handle='".$ararray['Handle']."',
                Name='".strip_nl($ararray['Name'])."',
                Maintainer_Name='".strip_nl($ararray['Maintainer-Name'])."',
                Maintainer_Email='".strip_nl($ararray['Maintainer-Email'])."',
                Maintainer_Phone='".strip_nl($ararray['Maintainer-Phone'])."',
                Maintainer_Fax='".strip_nl($ararray['Maintainer-Fax'])."',
                Description='".mysql_escape_string($ararray['Description'])."',
                URL='".strip_nl($ararray['URL'])."',
                Homepage='".strip_nl($ararray['Homepage'])."'
                WHERE ar_id='1'";

   mysql_query($query, $connection) or die ("Error in
                         query: $query. " . mysql_error());

// for all series ...
foreach ($archive['series'] as $serarray) {

	// get provider cluster
	$provider_clause="";
	if (isset($serarray['provider'][0])) {
		if (isset($serarray['provider'][0]['Provider-Name'])) 
			$provider_clause=$provider_clause." Provider_Name='".
			strip_nl($serarray['provider'][0]['Provider-Name'])."', ";
                if (isset($serarray['provider'][0]['Provider-Homepage'])) 
        		$provider_clause=$provider_clause." Provider_Homepage='".
			strip_nl($serarray['provider'][0]['Provider-Homepage'])."', ";
                if (isset($serarray['provider'][0]['Provider-Phone']))
                        $provider_clause=$provider_clause." Provider_Phone='".
                        strip_nl($serarray['provider'][0]['Provider-Phone'])."', ";
                if (isset($serarray['provider'][0]['Provider-Postal']))
                        $provider_clause=$provider_clause." Provider_Postal='".
                        strip_nl($serarray['provider'][0]['Provider-Postal'])."', ";
                if (isset($serarray['provider'][0]['Provider-Fax']))
                        $provider_clause=$provider_clause." Provider_Fax='".
                        strip_nl($serarray['provider'][0]['Provider-Fax'])."', ";
                if (isset($serarray['provider'][0]['Provider-Institution']))
                        $provider_clause=$provider_clause." Provider_Institution='".
                        strip_nl($serarray['provider'][0]['Provider-Institution'])."', ";
		}

	// get editor cluster
        $editor_clause="";
        if (isset($serarray['editor'][0])) {
                if (isset($serarray['editor'][0]['Editor-Name']))
                        $editor_clause=$editor_clause." Editor_Name='".
                        strip_nl($serarray['editor'][0]['Editor-Name'])."', ";
                if (isset($serarray['editor'][0]['Editor-Email']))
                        $editor_clause=$editor_clause." Editor_Email='".
                        strip_nl($serarray['editor'][0]['Editor-Email'])."', ";
                if (isset($serarray['editor'][0]['Editor-Workplace-Name']))
                        $editor_clause=$editor_clause." Editor_Workplace_Name='".
                        strip_nl($serarray['editor'][0]['Editor-Workplace-Name'])."', ";
                if (isset($serarray['editor'][0]['Editor-Workplace-Homepage']))
                        $editor_clause=$editor_clause." Editor_Workplace_Homepage='".
                        strip_nl($serarray['editor'][0]['Editor-Workplace-Homepage'])."', ";
                }

	// insert series
   	$query="INSERT into wp_series SET
		Name='".strip_nl($serarray['Name'])."',
		Classification_JEL='".strip_nl($serarray['Classification-JEL'])."',
		Restriction='".strip_nl($serarray['Restriction'])."',
		Notification='".strip_nl($serarray['Notification'])."',
		Maintainer_Name='".strip_nl($serarray['Maintainer-Name'])."',
		Maintainer_Email='".strip_nl($serarray['Maintainer-Email'])."',
		Order_Email='".strip_nl($serarray['Order-Email'])."',
		Order_Homepage='".strip_nl($serarray['Order-Homepage'])."',
		Order_Postal='".strip_nl($serarray['Order-Postal'])."',
		Price='".strip_nl($serarray['Price'])."',
		public_linking='direct',
		repec_sort='Handle',
		repec_sort_mode='DESC',
                Description='".mysql_escape_string($serarray['Description'])."', ".
		$provider_clause.$editor_clause.
                " Handle='".strip_nl($serarray['Handle'])."'";

   	mysql_query($query, $connection) or die ("Error in
                         query: $query. " . mysql_error());

	// get series id
	$ser_id=mysql_insert_id($connection);

	// now: for all papers in this series
	foreach($serarray['papers'] as $paper) {

		// build date strings
   		if (isset($paper['Creation-Date'])) {
			$CDstring=strip_nl($paper['Creation-Date']);
			$cyear=""; $cmonth=""; $cday="";
			if (preg_match("/^(\d{4})-(\d{1,2})-(\d{1,2})$/i",$CDstring,$matches)) {
				$cyear=$matches[1]; $cmonth=$matches[2]; $cday=$matches[3];
				}
			elseif (preg_match("/^(\d{4})-(\d{1,2})$/i",$CDstring,$matches)) {
                                $cyear=$matches[1]; $cmonth=$matches[2]; $cday=15;
                                }
                        elseif (preg_match("/^(\d{4})$/i",$CDstring,$matches)) {          
                                $cyear=$matches[1]; $cmonth=6; $cday=15;         
                                }
                        elseif (preg_match("/^.* (\d{4})$/i",$CDstring,$matches)) {          
                                $cyear=$matches[1]; $cmonth=6; $cday=15;          
                                }
			else    {
				$cyear=""; $cmonth=""; $cday="";
				}

			if ($cyear && $cmonth && $cday) {
        			$CDate=(int) $cyear * 10000 + (int) $cmonth * 100 + (int) $cday;
        			$Creation_Date= (string) $CDate;
				} else $Creation_Date="";
        		}
		   else {
        		$Creation_Date="";
        		}

                // build date strings   
                if (isset($paper['Revision-Date'])) {                          
                        $CDstring=strip_nl($paper['Revision-Date']);
                        $cyear=""; $cmonth=""; $cday="";
                        if (preg_match("/^(\d{4})-(\d{1,2})-(\d{1,2})$/i",$CDstring,$matches)) {
                                $cyear=$matches[1]; $cmonth=$matches[2]; $cday=$matches[3];
                                }
                        elseif (preg_match("/^(\d{4})-(\d{1,2})$/i",$CDstring,$matches)) {          
                                $cyear=$matches[1]; $cmonth=$matches[2]; $cday=15;         
                                }
                        elseif (preg_match("/^(\d{4})$/i",$CDstring,$matches)) {          
                                $cyear=$matches[1]; $cmonth=6; $cday=15;          
                                }
                        elseif (preg_match("/^.* (\d{4})$/i",$CDstring,$matches)) {
                                $cyear=$matches[1]; $cmonth=6; $cday=15;
                                }
                        else    {
                                $cyear=""; $cmonth=""; $cday="";           
                                }

                        if ($cyear && $cmonth && $cday) {
                                $CDate=(int) $cyear * 10000 + (int) $cmonth * 100 + (int) $cday;                 
                                $Revision_Date= (string) $CDate;
                                } else $Revision_Date="";
                        }       
                   else { 
                        $Revision_Date="";
                        }

   		// build authors string
		$authors=""; $auarray=array();
        	$i=0;
        	foreach ($paper['author'] as $author) {
          		if ($author['Author-Name']) {
                		$auarray[$i]=strip_nl($author['Author-Name']).';-;'.
					strip_nl($author['Author-Email']).';-;'.
					strip_nl($author['Author-Homepage']).';-;'.
					strip_nl($author['Author-Workplace-Name']).';-;'.
					strip_nl($author['Author-Workplace-Homepage']);
                		$i++;
                		}
        		}
        	if ($auarray[0]) $authors=implode("!-!",$auarray); else $authors="";

                // build files string
                $files=""; $fiarray=array();
                $i=0;
		if (isset($paper['file'])) {
                foreach ($paper['file'] as $file) {
                        if ($file['File-URL']) {
                                $fiarray[$i]=strip_nl($file['File-URL']).';-;'.
                                        strip_nl($file['File-Format']).';-;'.
                                        strip_nl($file['File-Restriction']).';-;'.
                                        strip_nl($file['File-Function']).';-;'.          
                                        strip_nl($file['File-Size']);    
                                $i++;
                                }
                        }
		     }
                if ($fiarray[0]) $files=implode("!-!",$fiarray); else $files="";

		// insert paper into database

        	$query="INSERT INTO wp_papers SET
			ser_id='".$ser_id."', 
			enable='y', 
			authors='".$authors."',
                 	Title='".strip_nl($paper['Title'])."', 
			Abstract='".mysql_escape_string($paper['Abstract'])."',
                 	Classification_JEL='".strip_nl($paper['Classification-JEL'])."', 
			Keywords='".strip_nl($paper['Keywords'])."', 
                 	Note='".mysql_escape_string($paper['Note'])."', 
			Length='".strip_nl($paper['Length'])."',
                 	Creation_Date='".$Creation_Date."', 
			Revision_Date='".$Revision_Date."',
                 	Number='".strip_nl($paper['Number'])."', 
			Publication_Status='".strip_nl($paper['Publication_Status'])."',
                 	Price='".strip_nl($paper['Price'])."', 
			files='".$files."', 
			Handle='".strip_nl($paper['Handle'])."'  ";
        mysql_query($query, $connection) or die ("Error in
                         query: $query. " . mysql_error());

		}

	}
}

?>
