--
-- Table structure for table `wp_archive`
--

CREATE TABLE wp_archive (
  ar_id int(11) NOT NULL default '1',
  Handle varchar(100) default NULL,
  Name varchar(255) default NULL,
  Maintainer_Name varchar(255) default NULL,
  Maintainer_Email varchar(255) default NULL,
  Maintainer_Phone varchar(255) default NULL,
  Maintainer_Fax varchar(255) default NULL,
  Description text,
  URL varchar(255) default NULL,
  Homepage varchar(255) default NULL,
  archive_path varchar(255) default '',
  PRIMARY KEY  (ar_id)
) TYPE=MyISAM;

--
-- Dumping data for table `wp_archive`
--

INSERT INTO wp_archive VALUES (1,'','','','','','','','','','');

--
-- Table structure for table `wp_papers`
--

CREATE TABLE wp_papers (
  p_id int(11) NOT NULL auto_increment,
  ser_id int(11) default NULL,
  enable char(1) default 'n',
  authors text,
  Title text,
  Abstract text,
  Classification_JEL varchar(255) default NULL,
  Keywords varchar(255) default NULL,
  Note text,
  Length varchar(255) default NULL,
  Creation_Date varchar(255) default NULL,
  Revision_Date varchar(255) default NULL,
  Number varchar(255) default NULL,
  Publication_Status varchar(255) default NULL,
  Price varchar(255) default NULL,
  files text,
  Handle varchar(255) default NULL,
  PRIMARY KEY  (p_id)
) TYPE=MyISAM;


--
-- Table structure for table `wp_series`
--

CREATE TABLE wp_series (
  ser_id int(11) NOT NULL auto_increment,
  Name varchar(255) default NULL,
  Description text,
  Classification_JEL varchar(255) default NULL,
  Restriction varchar(255) default NULL,
  Notification varchar(255) default NULL,
  Provider_Name varchar(255) default NULL,
  Provider_Homepage varchar(255) default NULL,
  Provider_Phone varchar(255) default NULL,
  Provider_Fax varchar(255) default NULL,
  Provider_Postal varchar(255) default NULL,
  Provider_Institution varchar(255) default NULL,
  Maintainer_Name varchar(255) default NULL,
  Maintainer_Email varchar(255) default NULL,
  Editor_Name varchar(255) default NULL,
  Editor_Email varchar(255) default NULL,
  Editor_Workplace_Name varchar(255) default NULL,
  Editor_Workplace_Homepage varchar(255) default NULL,
  Order_Email varchar(255) default NULL,
  Order_Homepage varchar(255) default NULL,
  Order_Postal varchar(255) default NULL,
  Price varchar(255) default NULL,
  Handle varchar(255) default NULL,
  repec_sort varchar(100) default '',
  repec_sort_mode varchar(100) default '',
  default_download_url varchar(255) default '',
  public_linking varchar(255) default '',
  series_offset int(11) default '0',
  admin_offset int(11) default '0',
  show_year char(1) default 'y',
  show_query char(1) default 'y',
  PRIMARY KEY  (ser_id)
) TYPE=MyISAM;


--
-- Table structure for table `wp_user`
--

CREATE TABLE wp_user (
  user_id int(11) NOT NULL auto_increment,
  username varchar(30) default NULL,
  password varchar(100) default NULL,
  superuser char(1) default 'n',
  PRIMARY KEY  (user_id)
) TYPE=MyISAM;

--
-- Dumping data for table `wp_user`
--

INSERT INTO wp_user VALUES (2,'repecadmin','reCCeKgLbbVJU','y');


